; SCREEN 7 512 colors ondemand

        org $D000-7

	DEFB #FE    ; BASIC header.
	DEFW BEGIN
        DEFW THEEND
	DEFW START

DATA   EQU #A000   ; Put your pallette data in this address
DATA2  EQU #A800
	    	 ; 16 * %0RRR0BBB, %00000GGG (32 bytes of first line pallette)
	    	 ; lines * 2 * %0000CCCC, %0RRR0BBB, %00000GGG (6 bytes / line)

BEGIN
START

        LD A,(#2D)
        CP 3
        LD A,#80
        CALL Z,#180 ; Change to Z80 if MSX tR

	CALL #44    ; Enable screen

	DI
 	IN A,(#AA)
 	AND #f0
 	or 8
 	OUT (#AA),A

	LD A,#90	 ; PALETTE register
	OUT (#99),A
	LD A,#91
	OUT (#99),A
AGAIN
	LD A,2
	OUT (#99),A
	LD A,#8F
	OUT (#99),A

        LD HL,DATA      ; even field...
        in a,($99)
        and 2
        jr nz,field0
        LD HL,DATA2     ; or odd field?
field0

      	XOR A
      	OUT (#9B),A
      	LD BC,#209A
      	OTIR	; First palette

	INC HL
	INC HL
	INC HL
	INC HL
	INC HL
	INC HL

	LD A,1
	OUT (#99),A
	LD A,#8F
	OUT (#99),A

WAITLINE0
	IN A,(#99)
	RRA
	JR NC,WAITLINE0

	LD A,2
	OUT (#99),A
	LD A,#8F
	OUT (#99),A

        LD E,210     ; Number of lines

        INC C
        OUTI
	DEC C
	OUTI
	OUTI

	INC C
	OUTI
	DEC C
	OUTI
	OUTI

WAIT
	IN A,(#99)
	AND 32
        JP Z,WAIT
;----------------------

        INC C
        OUTI
	DEC C
	OUTI
	OUTI

	INC C
	OUTI
	DEC C
	OUTI
	OUTI

	DEC E
	JP NZ,WAIT

;----------------------

     	IN A,(#A9)
	AND 1
	JP NZ,AGAIN ; SPACE pressed?

EXIT
	XOR A
	OUT (#99),A
	LD A,#8F
	OUT (#99),A
 	EI
	RET

THEEND
